"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

var _ = require("..");

var _utils = require("../../../tests/utils");

// import React from 'react';
// import { mount } from 'enzyme';
describe('Notify', function () {
  var wrapper;
  afterEach(function () {
    wrapper === null || wrapper === void 0 ? void 0 : wrapper.unmount();
    jest.restoreAllMocks();
  });
  test('should not throw error if calling clear method before render notify', function () {
    _.Notify.clear();
  });
  test('should render Notify correctly', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee() {
    return _regenerator().default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _.Notify.show('test');

            _context.next = 3;
            return (0, _utils.sleep)(10);

          case 3:
            expect(document.querySelector('.rc-notify')).toMatchSnapshot();

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  test('should add "rc-notify--success" class when type is success', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee2() {
    var notify;
    return _regenerator().default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _.Notify.show({
              message: 'test',
              type: 'success'
            });

            _context2.next = 3;
            return (0, _utils.sleep)(0);

          case 3:
            notify = document.querySelector('.rc-notify');
            expect(notify.classList.contains('rc-notify--success')).toBeTruthy();

          case 5:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  test('should change default duration after calling setDefaultOptions method', function () {
    _.Notify.setDefaultOptions({
      duration: 1000
    });

    expect(_.NotifyNamespace.currentOptions.duration).toEqual(1000);

    _.Notify.resetDefaultOptions();

    expect(_.NotifyNamespace.currentOptions.duration).toEqual(3000);
  });
  test('should reset to default duration after calling resetDefaultOptions method', function () {
    _.Notify.setDefaultOptions({
      duration: 1000
    });

    _.Notify.resetDefaultOptions();

    expect(_.NotifyNamespace.currentOptions.duration).toEqual(3000);
  });
  test('should call onClose option when closing', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee3() {
    var onClose;
    return _regenerator().default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            onClose = jest.fn();

            _.Notify.show({
              message: 'test',
              onClose: onClose,
              duration: 1
            });

            _context3.next = 4;
            return (0, _utils.sleep)(20);

          case 4:
            expect(onClose).toHaveBeenCalledTimes(1);

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
});